/**
 * 
 */
package com.materna.federatedcloudsim.federation;

import java.util.List;
import java.util.Map;

/**
 * @author Marc Spohr
 *
 */
public class Service implements Comparable<Service>
{
	private static int nextId = 0;
	private final int id;
	private final String name;
	private String desc;
	private Map<String,List<String>> possibleParamValues;

	/**
	 * @param name the name of this {@link Service} 
	 */
	public Service(String name)
	{
		this.name = name;
		id = nextId++;
		ServiceProviderRegistry.getInstance().registerService(this);
	}

	/**
	 * @return the name
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * @return the desc
	 */
	public String getDesc()
	{
		return desc;
	}

	/**
	 * @param desc the desc to set
	 */
	public void setDesc(String desc)
	{
		this.desc = desc;
	}

	/**
	 * @return the possibleParamValues
	 */
	public Map<String,List<String>> getPossibleParamValues()
	{
		return possibleParamValues;
	}

	/**
	 * @param possibleParamValues the possibleParamValues to set
	 */
	public void setPossibleParamValues(Map<String,List<String>> possibleParamValues)
	{
		this.possibleParamValues = possibleParamValues;
	}

	/**
	 * @return the id
	 */
	public int getId()
	{
		return id;
	}

	@Override
	public int compareTo(Service o) {
		int erg = 0;

		if (getId() < o.getId())
			erg = -1;
		else if (getId() == o.getId())
			erg = 0;
		else if (getId() > o.getId())
			erg = 1;
		return erg;
	}
}
