/**
 * 
 */
package com.materna.federatedcloudsim.scheduling.csp;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import com.materna.federatedcloudsim.FederatedDatacenter;
import com.materna.federatedcloudsim.FederatedHost;
import com.materna.federatedcloudsim.FederatedVm;
import com.materna.federatedcloudsim.federation.sla.Sla;

/**
 * Default implementation of {@link FederatedDatacenterBrokerStrategy}
 * @author Marc Spohr
 *
 */
public class FederatedDatacenterBrokerStrategySimple extends
		FederatedDatacenterBrokerStrategy
{
	
	/* (non-Javadoc)
	 * @see com.materna.federatedcloudsim.scheduling.datacenter.FederatedDatacenterBrokerStrategy#getDcId(com.materna.federatedcloudsim.federation.Sla)
	 */
	@Override
	public FederatedDatacenter getDc(Sla sla, List<Integer> dcIdsList)
	{
		if(getDcBroker().getCsp().provides(sla.getService()) && dcIdsList.size() > 0)
		{
			for(FederatedDatacenter dc : getDcBroker().getCsp().getDcList())
			{
				//Gets the First DC 
				//TODO Fill in code here
				//if(((FederatedVmAllocationPolicy) dc.getVmAllocationPolicy()).getFreePeNumber() >= Integer.parseInt(sla.getSlos().get("pesNumber")))
				//{
					return dc;
				//}
			}
		}
		return null;
	}
	
	@Override
	public FederatedDatacenter getDc(FederatedVm vm)
	{
		
		Sla sla = vm.getFirstCloudlet().getSr().getSla();
		
		if(getDcBroker().getCsp().provides(sla.getService()))
		{
			for(FederatedDatacenter dc : getDcBroker().getCsp().getDcList())
			{
				//Gets the First DC 
				//TODO Fill in code here
				//if(((FederatedVmAllocationPolicy) dc.getVmAllocationPolicy()).getFreePeNumber() >= Integer.parseInt(sla.getSlos().get("pesNumber")))
				//{
				if(vm.getHost().getDatacenter() != dc) {
					return dc;
				}	
				//}
			}
		}
		return null;
	}
	
	public ArrayList<FederatedVm> findVmsForMigration(ArrayList<FederatedVm> vmList, FederatedDatacenter dc) {
		
		
		ArrayList<FederatedVm> retList = new ArrayList<FederatedVm>();
		retList.addAll(vmList);
		//No strategy on broker level: Return the inputlist.
		return retList;
	}
	

	@Override
	public Map<FederatedVm, FederatedHost> findPossibleHost(FederatedVm fedVm) {
		Map<FederatedVm, FederatedHost> returnMap = new TreeMap<FederatedVm, FederatedHost>(); 
		
		return returnMap;
	}
}
