package com.materna.federatedcloudsim.scheduling.federation;

import java.util.Map;
import java.util.TreeMap;

import com.materna.federatedcloudsim.CloudServiceProvider;

public class AuctionMessage {
	
	private final Auction correspondingAuction;
	private boolean rejected = false;
	private boolean leadingOffer = false;
	private Map<String, String> biddingParameters;
	private int round;
	private final CloudServiceProvider participant;
	
	public AuctionMessage (Auction correspondingAuction, CloudServiceProvider participant){
		this.correspondingAuction = correspondingAuction;
		this.participant = participant;
		round = 1;		
		biddingParameters = new TreeMap<>();
	}

	/**
	 * @return the rejected
	 */
	public boolean isRejected() {
		return rejected;
	}

	/**
	 * @param rejected the rejected to set
	 */
	public void setRejected(boolean rejected) {
		this.rejected = rejected;
	}

	/**
	 * @return is the Auktionbid leading
	 */
	public boolean isLeading() {
		return leadingOffer;
	}

	/**
	 * @param leadingOffer the leadingOffer to set
	 */
	public void setLeadingOffer(boolean leadingOffer) {
		this.leadingOffer = leadingOffer;
	}

	/**
	 * @return the round
	 */
	public int getRound() {
		return round;
	}

	/**
	 * @param round the round to set
	 */
	public void setRound(int round) {
		this.round = round;
	}

	/**
	 * @return the correspondingAuction
	 */
	public Auction getCorrespondingAuction() {
		return correspondingAuction;
	}

	/**
	 * @return the participant
	 */
	public CloudServiceProvider getParticipant() {
		return participant;
	}

	/**
	 * @return the biddingParameters
	 */
	public Map<String, String> getBiddingParameters() {
		return biddingParameters;
	}

	/**
	 * @param biddingParameters the biddingParameters to set
	 */
	public void setBiddingParameters(Map<String, String> biddingParameters) {
		this.biddingParameters = biddingParameters;
	}

}
