package com.materna.federatedcloudsim.utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Random;

/**
 * 
 * @author Damian Pasternak
 *
 */

public class TraceWorkloadGenerator {

	public final static double SLA_GOLD_VALUE = 0.2;
	public final static double SLA_SILVER_VALUE = 0.3;
	public final static double SLA_BRONZE_VALUE = 0.5;
	public final static int VM_COUNT = 520;
	public static final String OUTPUT_FILE = "C:/Users/mpfahlbe/Desktop/FCS/experimente/workloads/materna_neu.swf";
	public static final String INPUT_TRACE_FOLDER = "C:/Users/mpfahlbe/Desktop/FCS/experimente/workloads/materna_neu/";

	public static void main(String[] args) {
		generate();
	}

	public static void generate() {

		String writeline = "";
		BufferedReader br = null;
		String line = "";
		String csvsplit = ";";
		int jobnr = 1;		// incremental job number
		int userId = 0;		// user-id; CloudSimConfigurator uses the uid to assign these swf (these vms) to the correct CSP (uid % #CSPs)
		int gold_sla = 0;
		int silver_sla = 0;
		int bronze_sla = 0;
		int rnd_val = 0;
		String[] logData;
		Random rn = new Random();
		boolean foundSlaLevel = false;
		long ramsum = 0;
		try {

			Writer writer = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(OUTPUT_FILE), "utf-8"));

			for (int i = 1; i <= 520; i++) {

				rnd_val = rn.nextInt(3) + 1;
				foundSlaLevel = false;

				while (!foundSlaLevel) {
					switch (rnd_val) {
					case 1:
						if (gold_sla < SLA_GOLD_VALUE * VM_COUNT) {
							foundSlaLevel = true;
							gold_sla++;
						} else {
							rnd_val = (rnd_val + 1) % 4;
						}
						break;
					case 2:
						if (silver_sla < SLA_SILVER_VALUE * VM_COUNT) {
							foundSlaLevel = true;
							silver_sla++;
						} else {
							rnd_val = (rnd_val + 1) % 4;
						}
						break;
					case 3:
						if (bronze_sla < SLA_BRONZE_VALUE * VM_COUNT) {
							foundSlaLevel = true;
							bronze_sla++;
						} else {
							rnd_val = (rnd_val + 1) % 4;
						}
						break;
					}
				}

				String csvFile = INPUT_TRACE_FOLDER + "/" + i + ".csv";
				br = new BufferedReader(new FileReader(csvFile));
				line = br.readLine(); // read first info line out
				logData = line.split(csvsplit);
				writeline = jobnr + // 1 JobNR
						" 0" + // 2 Submit Time
						" 0" + " " + // 3 Wait Time
						" 0" + " " + // 4 Runtime
						logData[1] + // 5 NUM Proc
						" " + " 0" + " " + // 6 CPU Time
						((long) (Double.parseDouble(logData[2])))*1024*1024  + // 7 MEM
																		// Used
						" " + logData[1] + " " // 8 CPU Requiered
						+ " 0" + " " + // 9 Runtime requiered
						((long) (Double.parseDouble(logData[2])))*1024*1024  + // 10 RAM
																		// requiered
						" " + rnd_val + // 11 the SLA-Level
						" " + userId	// user-id (uid) 
						+ " 1 1 -1 1 -1 -1"; // Irrelavant values
				writer.write(writeline + "\n");
				jobnr++;
				ramsum =  (ramsum + (long) Double.parseDouble(logData[2]));
			}
			writer.close();
			System.out.println((int) ramsum);

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static double[] arrayToDouble(String array[]) {

		double[] numArray = new double[array.length];
		for (int i = 0; i < array.length; i++) {
			numArray[i] = Double.parseDouble(array[i]);
		}
		return numArray;
	}
}
